#include "pm.h"

int main()
{   ifstream entrada("DatosDeEntradaCVRP.dat",ios::in);
    ofstream salida("salidaRutaCapacidades.txt");//salida
	double *dels,*drowlo, *drowup, *dcollo, *dcolup, *dobj, *costos,*demandas;
    int *mcolindx,*mrowindx; //indices
	int ncols,nelements,nrows,n1,m1,Q,i,j,v,k,p,s;

	//mximo 100 nudos y 10000 elementos no nulos;
	nrows=1500000;ncols=1500000;nelements=100000000;

	// reserva de memoria
	dels=new double[nelements];
	mcolindx=new int[nelements];mrowindx=new int[nelements];
	drowlo=new double[nrows];drowup=new double[nrows];
	dcollo=new double[ncols];dcolup=new double[ncols]; dobj=new double[ncols];
	costos=new double[ncols];demandas=new double[ncols];


	const int ccortes=0;

	double time1;

 //Lectura de datos, ndice inicial 0:
	//Nmero de nudos n1;
	entrada>>n1;
//Lectura de costos, funcin objetivo; Los mismos costos en cada tramo;
	for (i=0;i<n1;i++) for (j=0;j<n1;j++) entrada >> costos[i+j*n1];
	//Nmero de vehculos m1;
	entrada>>m1;
	//Capacidad de vehculos Q;
	entrada>>Q;
	//Demandas de los vrtices;
	for(i=0;i<n1;i++) entrada>>demandas[i];

int *enteras; enteras=new int[m1*n1*n1+n1*m1+n1*n1+n1];

//Pasar los coeficientes de la funcin objetivo y cotas de las variables
//tramos n1 porque hay que volver al origen;
  
for(v=0;v<m1;v++){
	for (i=0;i<n1;i++){
	    for (j=0;j<n1;j++){
			dobj[i+j*n1+v*n1*n1]=costos[i+j*n1];
			dcollo[i+j*n1+v*n1*n1]=0;
			dcolup[i+j*n1+v*n1*n1]=1;
			if(i==j) dcolup[i+j*n1+v*n1*n1]=0; // no de i a i
		} }}

for (k=0;k<n1;k++){	
	for(p=0;p<m1;p++){
		dcollo[m1*n1*n1+k+n1*p]=0;
		dcolup[m1*n1*n1+k+n1*p]=1;
	}}

for(i=0;i<n1;i++){	
	for(j=0;j<n1;j++){
		dcollo[m1*n1*n1+n1*m1+i+j*n1]=0;
		dcolup[m1*n1*n1+n1*m1+i+j*n1]=1;
              }}

for(s=0;s<n1;s++){	
	dcollo[m1*n1*n1+n1*m1+n1*n1+s]=0.;
	dcolup[m1*n1*n1+n1*m1+n1*n1+s]=1.0*(n1);
   }

int neleproblem=0;  
int rowsproblem=0;

			//RESTRICCIONES

//1) Cada cliente debe ser visitado una vez:

for(j=1;j<n1;j++){
	drowlo[rowsproblem]=1; drowup[rowsproblem]=1;
		for(v=0;v<m1;v++){
			for(i=0;i<n1;i++){
				if(i!=j){
					dels[neleproblem]=1; 
					mcolindx[neleproblem]=i+j*n1+v*n1*n1;
					mrowindx[neleproblem]=rowsproblem;
					neleproblem++;}}}
rowsproblem++;}

//2) Del depsito salen m1 vehculos:
drowlo[rowsproblem]=m1; drowup[rowsproblem]=m1;
	for(v=0;v<m1;v++){
		for(j=1;j<n1;j++){
			dels[neleproblem]=1; 
			mcolindx[neleproblem]=j*n1+v*n1*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;}}
rowsproblem++;

drowlo[rowsproblem]=m1; drowup[rowsproblem]=m1;
for(p=0;p<m1;p++){
	dels[neleproblem]=1; 
	mcolindx[neleproblem]=m1*n1*n1+n1*p;
	mrowindx[neleproblem]=rowsproblem;
    neleproblem++;}
rowsproblem++;

//3)El mismo nmero de vehculos que entran saldrn de cada cliente:
for (i=0;i<n1;i++){
	for (v=0;v<m1;v++){
		drowlo[rowsproblem]=0; drowup[rowsproblem]=0;
		for(j=0;j<n1;j++){
			dels[neleproblem]=1; 
			mcolindx[neleproblem]=i+j*n1+v*n1*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;}

			dels[neleproblem]=-1; 
			mcolindx[neleproblem]=m1*n1*n1+i+v*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;
rowsproblem++;}}

for (i=0;i<n1;i++){
	for (v=0;v<m1;v++){
		drowlo[rowsproblem]=0; drowup[rowsproblem]=0;
		for(j=0;j<n1;j++){
			dels[neleproblem]=1; 
			mcolindx[neleproblem]=j+i*n1+v*n1*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;}

			dels[neleproblem]=-1; 
			mcolindx[neleproblem]=m1*n1*n1+i+v*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;
rowsproblem++;}}

//4) Restricciones de capacidad:

for(v=0;v<m1;v++){
	drowlo[rowsproblem]=0; drowup[rowsproblem]=10;
		for(k=0;k<n1;k++){
			dels[neleproblem]=demandas[k]; 
			mcolindx[neleproblem]=m1*n1*n1+k+v*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;}
rowsproblem++;}

//5) Restricciones de relacin entre variables Yij
//El flujo del vrtice i al j se define por y_{ij}.

for(i=0;i<n1;i++){
	for (j=0;j<n1;j++){
		if (i!=j){
			drowlo[rowsproblem]=0.; drowup[rowsproblem]=0.;
			for(v=0;v<m1;v++){
				dels[neleproblem]=1.; 
				mcolindx[neleproblem]=i+j*n1+v*n1*n1;
				mrowindx[neleproblem]=rowsproblem;
				neleproblem++; }

			dels[neleproblem]=-1.; 
			mcolindx[neleproblem]=m1*n1*n1+n1*m1+i+j*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;
rowsproblem++;
			}}}

//6) Restricciones de eliminacin de subciclos:

//1
for(s=1;s<n1;s++){
	drowlo[rowsproblem]=0; drowup[rowsproblem]=1.0*(n1-1);
		dels[neleproblem]=1; 
		mcolindx[neleproblem]=n1*n1*m1+n1*m1+n1*n1+s;
		mrowindx[neleproblem]=rowsproblem;
		neleproblem++;

		dels[neleproblem]=1.0*(n1-2); 
		mcolindx[neleproblem]=n1*n1*m1+n1*m1+s*n1;
		mrowindx[neleproblem]=rowsproblem;
		neleproblem++;

		dels[neleproblem]=-1; 
		mcolindx[neleproblem]=n1*n1*m1+n1*m1+s;
		mrowindx[neleproblem]=rowsproblem;
		neleproblem++;
rowsproblem++;
			}

//2
for(s=1;s<n1;s++){
	drowlo[rowsproblem]=2; drowup[rowsproblem]=10^20;
		dels[neleproblem]=1; 
		mcolindx[neleproblem]=n1*n1*m1+n1*m1+n1*n1+s;
		mrowindx[neleproblem]=rowsproblem;
		neleproblem++;

		dels[neleproblem]=1; 
		mcolindx[neleproblem]=n1*n1*m1+n1*m1+s*n1;
		mrowindx[neleproblem]=rowsproblem;
		neleproblem++;

		dels[neleproblem]=1; 
		mcolindx[neleproblem]=n1*n1*m1+n1*m1+s;
		mrowindx[neleproblem]=rowsproblem;
		neleproblem++;
rowsproblem++;
			}
//3
for(s=1;s<n1;s++){
	for(k=1;k<n1;k++){
		if(k!=s){
			drowlo[rowsproblem]=-1.0*n1; drowup[rowsproblem]=1.0*(n1-1);
				dels[neleproblem]=1.; 
				mcolindx[neleproblem]=n1*n1*m1+n1*m1+n1*n1+s;
				mrowindx[neleproblem]=rowsproblem;
				neleproblem++; 

				dels[neleproblem]=-1.; 
				mcolindx[neleproblem]=n1*n1*m1+n1*m1+n1*n1+k;
				mrowindx[neleproblem]=rowsproblem;
				neleproblem++;

				dels[neleproblem]=1.0*(n1); 
				mcolindx[neleproblem]=n1*n1*m1+n1*m1+s+k*n1;
				mrowindx[neleproblem]=rowsproblem;
				neleproblem++;

				dels[neleproblem]=1.0*(n1-2); 
				mcolindx[neleproblem]=n1*n1*m1+n1*m1+k+s*n1;
				mrowindx[neleproblem]=rowsproblem;
				neleproblem++;
rowsproblem++;
		}}}

//4
for(s=1;s<n1;s++){
	drowlo[rowsproblem]=1; drowup[rowsproblem]=n1;
		dels[neleproblem]=1.; 
		mcolindx[neleproblem]=n1*n1*m1+n1*m1+n1*n1+s;
		mrowindx[neleproblem]=rowsproblem;
		neleproblem++; 
rowsproblem++;}


//		RESOLUCIN:

//Matriz por indices
	OsiClpSolverInterface sol1;
	CoinPackedMatrix A(true,mrowindx,mcolindx,dels,neleproblem);
	sol1.loadProblem(A,dcollo,dcolup,dobj,drowlo,drowup);
	sol1.setObjSense(1);
//salvar en formato mps;
	sol1.writeMps("RutaCapacidades");
//Solucin inicial lineal
    sol1.initialSolve(); 
	for (i=0;i<m1*n1*n1+n1*m1+n1*n1+n1;i++)  enteras[i]=i;
	for (i=0;i<m1*n1*n1+n1*m1+n1*n1+n1;i++) sol1.setInteger(enteras[i]);


if(ccortes==1){
	//CORTES:
	CglKnapsackCover cubrimientos;
    CglGomory gomory;
    CglProbing fijar;
	OsiCuts cortes1; 
    double obj = sol1.getObjValue();
    cubrimientos.generateCuts(sol1,cortes1); 
    gomory.generateCuts(sol1,cortes1);
    fijar.generateCuts(sol1,cortes1);

//se aplican si la efectividad es >=0.0 
	sol1.applyCuts(cortes1,0.0);
  
salida<<"\n APLICAMOS CORTES "<<"\n";
salida<<"\n El nmero de cortes es: "<<cortes1.sizeCuts()<<"\n";
if(cortes1.sizeCuts()>0){
	sol1.resolve();   
    salida <<"\n Despus de aplicar cortes el valor de la funcin objetivo ha cambiado de \n"<<obj <<" a " <<sol1.getObjValue();
	salida<< "\nNmero de variables:"<< sol1.getNumCols();
	salida<< "\nNmero de condiciones:"<< sol1.getNumRows(); 
	salida<< "\nFuncin objetivo:"<< sol1.getObjValue();
	salida<<"\nLa solucin es:";
	for (i=0;i<sol1.getNumCols();i++)salida<<"  "<< sol1.getColSolution()[i];
	salida<< "\n ";  
	   }

time1 = CoinCpuTime();
salida<<"\n El tiempo en realizar los cortes de CPU es: "<<time1;
salida<<"\n";
salida<<"\n";}

//   Branch and Bound:


sol1.branchAndBound();
if (sol1.getObjValue()>1e31){ salida << "MIP Unbounded"; goto fin; }
if (!sol1.isProvenOptimal()){ salida << " The optimum is not found"; goto fin; }
salida<<"\n SOLUCIN ENTERA "<<"\n";
salida<<"\n Nmero de nudos:"<< n1; 
salida<<"\n Nmero de vehculos:"<< m1;
salida<<"\n Capacidad de vehculos:"<< Q;
salida<<"\n Demandas:";for(i=0;i<n1;i++){salida<< " "<<demandas[i];}
salida<< "\n Funcin objetivo:"<< sol1.getObjValue(); 
salida<< "\n Nmero de variables:"<< sol1.getNumCols();
salida<< "\n Nmero de condiciones:"<< sol1.getNumRows(); 
salida<<"\n La  solucin actual  es:\n"; 
salida<< "\n ";
double gasto;
for(v=0;v<m1;v++){
	gasto=0.;
	salida<< "vehculo ****** "<< v+1<<"\n";
	for(j=0;j<n1;j++){
		for(i=0;i<n1;i++){
			if(abs(sol1.getColSolution()[v*n1*n1+j*n1+i])>1.e-8){
				gasto=gasto+demandas[i];
				salida<<"Origen "<<i+1<<"  Destino "<<j+1<<"  "<<"\n ";}
				} }
	salida<<"Gastos en demandas: "<<gasto<<"\n ";}

salida<<"\n";
salida<<"\n";

//X_{ijv}
for (v=0;v<m1;v++) {
	salida<<"\n";
	for(j=0;j<n1;j++){
		salida<<"\n";
		for(i=0;i<n1;i++){
			salida<< "("<<i+1<<","<<j+1<<","<<v+1<<")"<<sol1.getColSolution()[v*n1*n1+j*n1+i]<<" ";}}}

salida<<"\n";
salida << "\n";
salida << "\n";
	
// Y_{ij}
salida << "Yij\n";
for (j = 0; j<n1; j++){
	salida << " \n";
	for (i = 0; i<n1; i++){
		salida << "(" << j + 1 << "," << i + 1 << ")" << sol1.getColSolution()[n1*n1*m1 +n1*m1+ i*n1+j] << " ";
		 }
	 }

salida << "\n";
	 
//U_s
salida << "\n  ***   Us\n";
for (j = 0; j<n1; j++){
	salida <<"vrtice: "<< j + 1 << " visitado en el orden: " << 1+sol1.getColSolution()[n1*n1*m1 +n1*m1+ n1*n1+ j] << " ";
	salida << "\n";
		}

double time2= CoinCpuTime();
salida<<"\n El tiempo resolver el problema entero de CPU es: "<<time2;
salida<<"\n";
salida<<"\n";

if(ccortes==1){
	salida<<"\n El tiempo resolucin total de CPU es: "<<(time2 + time1);}

fin:

entrada.close();
salida.close();
return 0;
}  

