#include "pm.h"

int main()
{   ifstream entrada("DatosDeEntrada_Clusters_Vehculos.dat",ios::in);
    ofstream salida("salidaGTsp.txt");//salida
	double *dels,*drowlo, *drowup, *dcollo, *dcolup, *dobj, *costos;
    int *mcolindx,*mrowindx; //ndices
	int ncols,nelements,nrows,n1,nclusters,i,j,k,s,r;

	//mximo 100 nudos y 10000 elementos no nulos;
	nrows=100000;ncols=100000;nelements=10000000;

	// Reserva de memoria
	dels=new double[nelements];
	mcolindx=new int[nelements];mrowindx=new int[nelements];
	drowlo=new double[nrows];drowup=new double[nrows];
	dcollo=new double[ncols];dcolup=new double[ncols]; dobj=new double[ncols];
	costos=new double[ncols];

//Lectura de datos, ndice inicial 0;
	//Nmero de nudos n1;
	entrada>>n1;
//Lectura de costos, funcin objetivo;Los mismos costos en cada tramo;
	for (i=0;i<n1;i++) for (j=0;j<n1;j++) entrada >> costos[i+j*n1];
	//Nmero de clusters, t:
	entrada>>nclusters;
	//Divisin de los clusters:
	int clusters[100][100];
	for (s=0;s<nclusters;s++) for (j=0;j<n1;j++) entrada>> clusters[s][j];

//Pasar los coeficientes de la funcin objetivo y cotas de las variables
//tramos n1 porque hay que volver al origen;
for (i=0;i<n1;i++){
	for (j=0;j<n1;j++){
		dobj[i+j*n1]=costos[i+j*n1];
		dcollo[i+j*n1]=0;
		dcolup[i+j*n1]=1;
		if(i==j) dcolup[i+j*n1]=0; // no de i a i
	} }

for(s=0;s<nclusters;s++){	
	for(r=0;r<nclusters;r++){
		dcollo[n1*n1+s+r*nclusters]=0;
		dcolup[n1*n1+s+nclusters*r]=1;
       }}

for(s=0;s<nclusters;s++){	
	dcollo[n1*n1+nclusters*nclusters+s]=0.;
	dcolup[n1*n1+nclusters*nclusters+s]=1.0*(nclusters);
     }

int *enteras; enteras=new int[n1*n1+nclusters*nclusters+nclusters];

int neleproblem=0;  
int rowsproblem=0;


//	RESTRICCIONES:

//Restricciones de flujo en los clusters:
//1)
for(s=0;s<nclusters;s++){
	drowlo[rowsproblem]=1.; drowup[rowsproblem]=1.;
	for(i=0;i<n1;i++){
		if(clusters[s][i]!=0){
			for (k=0;k<nclusters;k++){
				if (k!=s){
					for(j=0;j<n1;j++){
						if(clusters[k][j]!=0){
							dels[neleproblem]=1.; 
							mcolindx[neleproblem]=i+j*n1;
							mrowindx[neleproblem]=rowsproblem;
							neleproblem++;}}}}}}
rowsproblem++;}

//2)
for(s=0;s<nclusters;s++){
	drowlo[rowsproblem]=1; drowup[rowsproblem]=1;
	for(j=0;j<n1;j++){
		if(clusters[s][j]!=0){
			for (k=0;k<nclusters;k++){
				if (k!=s){
					for(i=0;i<n1;i++){
						if(clusters[k][i]!=0){
							dels[neleproblem]=1.; 
							mcolindx[neleproblem]=i+j*n1;
							mrowindx[neleproblem]=rowsproblem;
							neleproblem++;}}}}}}
rowsproblem++;}


//Restricciones de equilibrio de flujo en los vrtices
for(i=0;i<n1;i++){
	drowlo[rowsproblem]=0.; drowup[rowsproblem]=0.;
	for(j=0;j<n1;j++){
		if(j!=i){
			dels[neleproblem]=1.; 
			mcolindx[neleproblem]=j+i*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;

			dels[neleproblem]=-1.; 
			mcolindx[neleproblem]=i+j*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;}}

rowsproblem++;}

//Restricciones de relacin entre variables Usq
for(s=0;s<nclusters;s++){
	for (k=0;k<nclusters;k++){
		if (k!=s){
			drowlo[rowsproblem]=0.; drowup[rowsproblem]=0.;
			for (i=0;i<n1;i++){
				if(clusters[s][i]!=0){
					for (j=0;j<n1;j++){
						if(clusters[k][j]!=0){
							dels[neleproblem]=1.; 
							mcolindx[neleproblem]=i+j*n1;
							mrowindx[neleproblem]=rowsproblem;
							neleproblem++; }}}}

			dels[neleproblem]=-1.; 
			mcolindx[neleproblem]=n1*n1+s+k*nclusters;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;

 rowsproblem++;
			}}}

//Restricciones de eliminacin de subciclos Us
for(s=1;s<nclusters;s++){
	for(k=1;k<nclusters;k++){
		if(k!=s){
			drowlo[rowsproblem]=-1.0*nclusters; drowup[rowsproblem]=1.0*(nclusters-1);
			dels[neleproblem]=1.; 
			mcolindx[neleproblem]=n1*n1+nclusters*nclusters+s;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++; 

			dels[neleproblem]=-1.; 
			mcolindx[neleproblem]=n1*n1+nclusters*nclusters+k;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;

			dels[neleproblem]=1.0*(nclusters); 
			mcolindx[neleproblem]=n1*n1+s+nclusters*k;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;

			dels[neleproblem]=1.0*(nclusters-2); 
			mcolindx[neleproblem]=n1*n1+k+nclusters*s;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;

 rowsproblem++;
		}}}

////Restricciones de limitacin de variables auxiliares:

for(s=1;s<nclusters;s++){
	drowlo[rowsproblem]=1; drowup[rowsproblem]=10000000;
		dels[neleproblem]=1; 
		mcolindx[neleproblem]=n1*n1+nclusters*nclusters+s;
		mrowindx[neleproblem]=rowsproblem;
		neleproblem++; 

		for(k=1;k<nclusters;k++){
			if(k!=s){
				dels[neleproblem]=-1; 
				mcolindx[neleproblem]=n1*n1+k+s*nclusters;
				mrowindx[neleproblem]=rowsproblem;
				neleproblem++;}}

rowsproblem++;
			}


for(s=1;s<nclusters;s++){
	drowlo[rowsproblem]=0; drowup[rowsproblem]=1.0*nclusters;
	dels[neleproblem]=1; 
	mcolindx[neleproblem]=n1*n1+nclusters*nclusters+s;
	mrowindx[neleproblem]=rowsproblem;
	neleproblem++;

	dels[neleproblem]=1.0*(nclusters-1); 
	mcolindx[neleproblem]=n1*n1+nclusters*s;
	mrowindx[neleproblem]=rowsproblem;
	neleproblem++;

rowsproblem++;
			}

//	RESOLUCIN:
				
//Matriz por indices
	OsiClpSolverInterface sol1;
	CoinPackedMatrix A(true,mrowindx,mcolindx,dels,neleproblem);
	sol1.loadProblem(A,dcollo,dcolup,dobj,drowlo,drowup);
	sol1.setObjSense(1); 

//salvar en formato mps;
    sol1.writeMps("GTSP");

//	Solucin inicial lineal

sol1.initialSolve(); 
for (i=0;i<n1*n1+nclusters*nclusters+nclusters;i++)  enteras[i]=i;
for (i=0;i<n1*n1+nclusters*nclusters+nclusters;i++) sol1.setInteger(enteras[i]);
sol1.branchAndBound();
if (sol1.getObjValue()>1e31){ salida << "MIP Unbounded"; goto fin; }
if (!sol1.isProvenOptimal()){ salida << " The optimum is not found"; goto fin; }
salida << "\n Nmero de clusters: " << nclusters;
salida << "\n Nmero de nudos: " << n1;
salida << "\n Funcin objetivo: " << sol1.getObjValue();
salida << "\n Nmero de variables: " << sol1.getNumCols();
salida << "\n Nmero de condiciones: " << sol1.getNumRows();
salida << "\n La  solucin actual  es:\n";
salida << "\n ";

for (s = 0; s<nclusters; s++){
	salida << "\n " << " cluster " << s + 1 << "\n ";
	for (i = 0; i<n1; i++){
		if (clusters[s][i] != 0){
			salida << "vrtice " << i + 1 << "  ";
			 }
		 }
	 }	 
salida << "\n ";
salida << "\n ";

//X_{ij}
for (j = 0; j<n1; j++){
	for (i = 0; i<n1; i++){
		if (abs(sol1.getColSolution()[j*n1 + i])>1.e-8){
			salida << "Origen " << i + 1 << "  Destino " << j + 1 << "  " << "\n ";
			 }
		 }
	 }
salida << "\n";
salida << "\n";

for (j = 0; j<n1; j++){
	salida << "\n";
	for (i = 0; i<n1; i++){
		salida << "(" << i + 1 << "," << j + 1 << ")" << int(sol1.getColSolution()[j*n1 + i]) << " ";
		 }
	 }
salida << "\n";

//U_s
salida << "\n  ***   Us\n";
for (j = 0; j<nclusters; j++){
	salida <<"cluster: "<< j + 1 << " visitado en el orden: " << 1+sol1.getColSolution()[n1*n1 + nclusters*nclusters + j] << " ";
	salida << "\n";
	 }
salida << "\n";
salida << "\n";

//W_{sq}
salida << "Wsq\n";
for (j = 0; j<nclusters; j++){
	salida << " \n";
	for (i = 0; i<nclusters; i++){
		salida << "(" << j + 1 << "," << i + 1 << ")" << sol1.getColSolution()[n1*n1 + i*nclusters+j] << " ";
		 }
	 }

fin:

entrada.close();
salida.close();
return 0;
}  
