#include "pm.h"
int main()
{   ifstream entrada("DatosDeEntrada_Vehculos.dat",ios::in);
    ofstream salida("salidamTSP.txt");//salida
	double *dels,*drowlo, *drowup, *dcollo, *dcolup, *dobj, *costos;
    int *mcolindx,*mrowindx; //ndices
	int ncols,nelements,nrows,n1,m1,i,j,s,k;

	//mximo 100 nudos y 10000 elementos no nulos;
	nrows=1000;ncols=1000;nelements=10000;

	// Reserva de memoria
	dels=new double[nelements];
	mcolindx=new int[nelements];mrowindx=new int[nelements];
	drowlo=new double[nrows];drowup=new double[nrows];
	dcollo=new double[ncols];dcolup=new double[ncols]; dobj=new double[ncols];
	costos=new double[ncols];

// Lectura de datos, ndice inicial 0;	 
	//Nmero de nudos n1;
	entrada>>n1;            
//Lectura de costos, funcin objetivo;Los mismos costos en cada tramo;
		for (i=0;i<n1;i++) for (j=0;j<n1;j++) entrada >> costos[i+j*n1];
	//Nmero de vehculos m1;
	entrada>>m1;


//Pasar a coeficientes de la funcin objetivo y cotas de las variables
//tramos n1 porque hay que volver al origen;

for (i=0;i<n1;i++){
	for (j=0;j<n1;j++){
		dobj[i+j*n1]=costos[i+j*n1];
		dcollo[i+j*n1]=0.;
		dcolup[i+j*n1]=1.;
		if(i==j) dcolup[i+j*n1]=0.; // no de i a i
	} }

for(s=0;s<n1;s++){	
	dcollo[n1*n1+s]=0.;
	dcolup[n1*n1+s]=1.0*(n1);
   }

int *enteras; enteras=new int[n1*n1+n1];

int neleproblem=0;  
int rowsproblem=0;


//	RESTRICCIONES :


//A cada vrtice llega un unico camino:
for (j=1;j<n1;j++){
	drowlo[rowsproblem]=1; drowup[rowsproblem]=1;
	for(i=0;i<n1;i++){
		if(i!=j){
			dels[neleproblem]=1; 
			mcolindx[neleproblem]=i+j*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++; }}
 rowsproblem++;}
 
//De cada vrtice sale un unico camino:
for (j=1;j<n1;j++){
	drowlo[rowsproblem]=1; drowup[rowsproblem]=1;
	for(i=0;i<n1;i++){
		if(i!=j){
			dels[neleproblem]=1; 
			mcolindx[neleproblem]=j+i*n1;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++; }}
rowsproblem++;}

//Del depsito salen m1 vehculos y vuelven m1.
 //1)
drowlo[rowsproblem]=1.0*m1; drowup[rowsproblem]=1.0*m1;
for (j=1;j<n1;j++){
	dels[neleproblem]=1.; 
	mcolindx[neleproblem]=j*n1;
	mrowindx[neleproblem]=rowsproblem;
	neleproblem++; }
rowsproblem++;

//2) 
drowlo[rowsproblem]=m1; drowup[rowsproblem]=m1;
for (i=1;i<n1;i++){
	dels[neleproblem]=1; 
	mcolindx[neleproblem]=i;
	mrowindx[neleproblem]=rowsproblem;
	neleproblem++; }
rowsproblem++; 

//Restricciones de eliminacin de subciclos:
//1
for(s=1;s<n1;s++){
	drowlo[rowsproblem]=0; drowup[rowsproblem]=1.0*(n1-1);
	dels[neleproblem]=1; 
	mcolindx[neleproblem]=n1*n1+s;
	mrowindx[neleproblem]=rowsproblem;
	neleproblem++;

	dels[neleproblem]=1.0*(n1-2); 
	mcolindx[neleproblem]=n1*s;
	mrowindx[neleproblem]=rowsproblem;
	neleproblem++;

	dels[neleproblem]=-1; 
	mcolindx[neleproblem]=s;
	mrowindx[neleproblem]=rowsproblem;
	neleproblem++;

rowsproblem++;
			}

//2
for(s=1;s<n1;s++){
	drowlo[rowsproblem]=2; drowup[rowsproblem]=10^20;
	dels[neleproblem]=1; 
	mcolindx[neleproblem]=n1*n1+s;
	mrowindx[neleproblem]=rowsproblem;
	neleproblem++;

	dels[neleproblem]=1; 
	mcolindx[neleproblem]=n1*s;
	mrowindx[neleproblem]=rowsproblem;
	neleproblem++;

	dels[neleproblem]=1; 
	mcolindx[neleproblem]=s;
	mrowindx[neleproblem]=rowsproblem;
	neleproblem++;

rowsproblem++;
			}

//3
for(s=1;s<n1;s++){
	for(k=1;k<n1;k++){
		if(k!=s){
			drowlo[rowsproblem]=-1.0*n1; drowup[rowsproblem]=1.0*(n1-1);
			dels[neleproblem]=1.; 
			mcolindx[neleproblem]=n1*n1+s;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;

			dels[neleproblem]=-1.; 
			mcolindx[neleproblem]=n1*n1+k;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;

			dels[neleproblem]=1.0*(n1); 
			mcolindx[neleproblem]=s+n1*k;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;

			dels[neleproblem]=1.0*(n1-2); 
			mcolindx[neleproblem]=k+n1*s;
			mrowindx[neleproblem]=rowsproblem;
			neleproblem++;

 rowsproblem++;
		}}}
  

//		RESOLUCIN:

//Matriz por indices
	OsiClpSolverInterface sol1;
	CoinPackedMatrix A(true,mrowindx,mcolindx,dels,neleproblem);
	sol1.loadProblem(A,dcollo,dcolup,dobj,drowlo,drowup);
	sol1.setObjSense(1); 
//salvar en formato mps;
	sol1.writeMps("mTSP");

//Solucin inicial lineal
	sol1.initialSolve(); 
	for (i=0;i<n1*n1+n1;i++)  enteras[i]=i;
	for (i=0;i<n1*n1+n1;i++) sol1.setInteger(enteras[i]);

//		Branch and Bound:

sol1.branchAndBound();
if (sol1.getObjValue()>1e31){ salida << "MIP Unbounded"; goto fin; }
if (!sol1.isProvenOptimal()){ salida << " The optimum is not found"; goto fin; }
salida<<"\n Nmero de nudos: "<<n1;
salida<<"\n Nmero de vehculos: "<<m1;
salida<< "\n Funcin objetivo: "<< sol1.getObjValue(); 
salida<< "\n Nmero de variables: "<< sol1.getNumCols();
salida<< "\n Nmero de condiciones: "<< sol1.getNumRows();
salida<<"\n La  solucin actual  es:\n"; 
salida<< "\n ";
salida<< "\n ";

//X_{ij}
for(j=0;j<n1;j++){
	for(i=0;i<n1;i++){
		if(abs(sol1.getColSolution()[j*n1+i])>1.e-8){
			salida<<"Origen "<<i+1<<"  Destino "<<j+1<<"  "<<"\n ";}}}

salida<<"\n";
salida<<"\n";

for(j=0;j<n1;j++){
	salida<<"\n";
	for(i=0;i<n1;i++){
		salida<< "("<<i+1<<","<<j+1<<")"<<int(sol1.getColSolution()[j*n1+i])<<" ";}}
salida << "\n";

//U_s
salida << "\n  ***   Us\n";
for (j = 0; j<n1; j++){
	salida <<"vrtice: "<< j + 1 << " visitado en el orden: " << 1+sol1.getColSolution()[n1*n1 +  j] << " ";
	salida << "\n"; 
	 }


fin:

entrada.close();
salida.close();
return 0;
}  